# load me

import math

types = {
    'r':'r',
    'radius': 'r',
    'd': 'd',
    'diameter': 'd',
    'a': 'a',
    'area': 'a',
    'circumference': 'c',
    'c': 'c'
}




def fromD(di):
    r = di/2
    return r

def fromC(ce):
    r = ce / 6.28
    return r

def fromA(ar):
    r = math.sqrt(ar/3.14)
    return r

def fromR(r):
    return r

fr = {
    'r': fromR,
    'd': fromD,
    'a': fromA,
    'c': fromC
}



def rOP(self, t, i):
    r = fr[t](i)
    return "the radius of your circle is {} units".format(r)

def dOP(self, t, i):
    r = fr[t](i)
    return "the diameter of your circle is {} units".format(r*2)

def aOP(self, t, i):
    r = fr[t](i)
    return "the area of your circle is {} units".format(3.14 * (r*r))

def cOP(self, t, i):
    r = fr[t](i)
    return "the circumference of your circle is {} units".format(3.14*(r*2))

ops = {
    'r': rOP,
    'd': dOP,
    'a': aOP,
    'c': cOP
}




def gettype(inp):
    i = inp[-1:]
    if i in types:
        return types[i]
    else:
        return 'r'

def circle(self, c,n,m):
    m = m.split()
    if len(m) < 3:
        self.say(c, 'Invalid input, do {}help circle to see syntax'.format(self.prefix))
        return
    m.pop(0)
    o = m.pop(0)
    if o in types:
        o = types[o]
    else:
        self.say(c, 'Invalid input, do {}help circle to see syntax'.format(self.prefix))
        return
    t = gettype(m[0])
    try:
        m = float(m[0][:-1])
    except:
        self.say(c, 'Invalid input, do {}help circle to see syntax'.format(self.prefix))
        return
    self.say(c, ops[o](self, t, m))

def init(self):
    self.registerCommand('circle', circle)
    self.registerCommand('c', circle)
    self.registerHelp('circle', 'circle <output type letter> <input><type letter> - calculate mesurements of a circle. the valid types are r: radius, d: diameter, a: area, and c: circumference')


