.TH CIRCLES 1 "12 March 2020"
.SH NAME
circles \- general math IRC bot
.SH SYNOPSIS
\fBhelp\fP [\fIcommand\fP]

\fBcircle\fP {c|r|a|d} \fIinput\fP{c|r|a|d}

\fBsql\fP \fIsql-statement\fP

\fBmodules\fP

\fBping\fP

\fBstonks\fP {tokens | balance [\fIuser\fP] [\fItoken\fP] |
send \fIto\fP \fIamount\fP \fItoken\fP | create \fItoken\fP}

\fBxp\fP {show [\fIuser\fP] | top}

.SH DESCRIPTION
\fBcircles\fP is a general math IRC bot originally designed to
solve geometry problems, but has strayed from the original use.

circles is also quite modular, and is based on khuxkm's teambot
IRC library.

.SH OPTIONS

.SS circle

.TP
.BR { c | r | a | d }

Specify the output type you would like.

.TP
.BR \fIinput\fP

Input the value of part of the circle you know.

.TP
.BR { c | r | a | d }

Specify the input's type.

.SS sql

.TP
.BR \fIsql-statement\fP

The SQL statement you would like to be executed.

.SS stonks

Because the stonks arguments are fairly self-explanitory,
the manual will not go too far in depth.

.TP
.BR tokens

List all the stonks tokens that currently exist.

.TP
.BR send

Send some of a token to a user

.TP
.BR balance

Get the balance of your own or someone else's token. If you are running the
command on yourself (not specifying a user) you can use \fB*\fP as the
token type to list all of your tokens.

.TP
.BR create

Create your very own stonks token!

.SS xp

A random amount of 0-15 xp is awarded every time you send a message,
with a cooldown of 1 minute to prevent getting xp by quickly spamming.

Thus, the xp will show overall who is active over time, and not by
how quickly they can send messages.

.TP
.BR top

Get a leaderboard of the top 10 people with xp.

.TP
.BR show

Show your amount of xp or someone else's

.SH "GETTING HELP"

You can ask for help in IRC on tilde.chat #lickthecheese if the help command is inadequate.

.SH BUGS
bug reports can be filed at https://tildegit.org/lickthecheese/circles/issues

