# base commands like help

def helpList(self,c):
    self.say(c,'available commands: '+' '.join(list(self.help.keys())))

def help(self, c,n,m):
    m = m.split().pop()
    if m in list(self.help.keys()):
        self.say(c,self.help[m])
    else:
        helpList(self,c)
    
def listMods(self, c,n,m):
    self.say(c, 'Loaded Modules: '+' '.join(self.lm))

def init(self):
    self.registerCommand('help', help)
    self.registerHelp('help', 'help [command] - get help with a command')
    
    self.registerCommand('modules', listMods)
    self.registerHelp('modules', 'modules - list the loaded modules')




