# load me

import json, yaml, time, random

def loadJson(self):
    try:
        with open('modules/xp.json') as json_file:
            data = json.load(json_file)
            self.xpData = data
    except FileNotFoundError:
        print('not found')

def writeJson(self):
    with open('modules/xp.json', 'w') as outfile:
        json.dump(self.xpData, outfile)
        #print(json.dumps(self.xpData))

def giveXp(self, n):
        ran = int(random.uniform(-1, 20))
        try:
            self.xpData[n] += ran
        except:
            self.xpData[n] = ran

def showXp(self, c, n, m):
    if len(m) < 1:
        try:
            self.say(c, "your chat xp is {}.".format(self.xpData[n]))
        except:
            self.say(c, 'you have no xp.')
    else:
        try:
            self.say(c, "{}'s chat xp is {}.".format(m[0], self.xpData[m[0]]))
        except:
            self.say(c, '{} has no chat xp'.format(m[0]))

def lead(self, c, n, m):
    out = 'The XP leaderboard: '
    for i in sorted(self.xpData, key=self.xpData.get, reverse=True)[:10]:
        out += '{}: {}, '.format(i[:1]+'\u200b'+i[1:], self.xpData[i])
    self.say(c, out[:-2])

cmds = {
    "show": showXp,
    "top": lead
}

def onMessage(self, c, n, m):
    #try:
        if not n in self.xpTime:
            self.xpTime[n] = 0
        if time.time() - 60 > self.xpTime[n]:
            #loadJson(self)
            giveXp(self, n)
            writeJson(self)
            self.xpTime[n] = time.time()
    #except:
    #    print('error lol')


def parseCommand(self, c,n,m):
    m = m.split()
    if len(m) < 2:
        self.say(c, 'do {}xp help for syntax'.format(self.prefix))
        return
    m.pop(0)
    cmd = m.pop(0)
    if cmd in cmds:
        #loadJson(self)
        cmds[cmd](self, c, n, m)
        writeJson(self)
    else:
        self.say(c,'availible options are top, show [user]')

def init(self):
    self.xpTime = {}
    loadJson(self)
    self.registerCommand('xp', parseCommand)
    self.registerRaw('xpGiver', onMessage)
    self.registerHelp('xp', 'xp - get xp points for chatting in channels with circles in it')
 

   

